<?php

namespace Drupal\expay\Events;

require_once __DIR__ . '/ExpayBaseEvent.php';

/** Class for processing 'Check' requests from Expay Callback API */
class ExpayEventCheck extends ExpayBaseEvent {
  public function handle($event) {
    if (!$this->isHashValid($event)) {
      return $this->sendResponse(401, 'Invalid hash');
    }

    if (!$this->isOrderValid($event)) {
      return $this->sendResponse(475, 'Payment with the specified parameters can not be processed');
    }

    if (!$this->amountMatching($event) || $this->isOrderCanceled() || $this->isOrderPaid()) {
      return $this->sendResponse(475, 'Payment with the specified parameters can not be processed');
    }

    \Drupal::logger('Expay Webhooks')->info('Expay Webhooks: check of order#' . $this->payment->getOrderId() . ' was successful');

    return $this->sendResponse(270, 'account exist');
  }
}

