<?php

namespace Drupal\expay\Events;

use Drupal\commerce_payment\Entity\PaymentInterface;
use Symfony\Component\HttpFoundation\JsonResponse;

/** Class for handling requests from Expay Callback API */
class ExpayEventHandler {
  public function handle($event, PaymentInterface $payment) {
    if (!isset($event['method'])) {
      return new JsonResponse(null, 400);
    }

    switch ($event['method']) {
      case 'check':
        \Drupal::logger('Expay Webhooks')->info('event CHECK (order#' . $event['order'] . ') has been caught.');
        $expay_event = new ExpayEventCheck($payment);
        break;

      case 'pay':
        \Drupal::logger('Expay Webhooks')->info('event PAY (order#' . $event['order'] . ') has been caught.');
        $expay_event = new ExpayEventPay($payment);
        break;

      default:
        return new JsonResponse(null, 400);
    }

    return $expay_event->handle($event);
  }
}