<?php

namespace Drupal\expay\Plugin\Commerce\PaymentMethodType;

use Drupal\commerce\BundleFieldDefinition;
use Drupal\commerce_payment\Entity\PaymentMethodInterface;
use Drupal\commerce_payment\Plugin\Commerce\PaymentMethodType\PaymentMethodTypeBase;

/**
 * ExpayMethodType payment method type.
 *
 * @CommercePaymentMethodType(
 *   id = "expay",
 *   label = @Translation("Expay Payment"),
 *   create_label = @Translation("Expay Payment")
 * )
 */
class ExpayMethodType extends PaymentMethodTypeBase {
  /**
   * Builds a label for the given payment method.
   *
   * @param PaymentMethodInterface $payment_method
   *   The payment method.
   *
   * @return string
   *   The label.
   */
  public function buildLabel(PaymentMethodInterface $payment_method)
  {
    return $this->t('Expay Payment');
  }

  /**
   * {@inheritdoc}
   */
  public function buildFieldDefinitions() {
    $fields = parent::buildFieldDefinitions();

    $fields['list'] = BundleFieldDefinition::create('list_string')
        ->setLabel(t('Expay list of attributes'))
        ->setDescription(t('List of attributes for initializing payment'));

    return $fields;
  }
}